<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">

    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['system:auditInfo:remove']">删除</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="auditInfoList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="应用名称" align="center" prop="name" />
        <el-table-column label="节点" align="center" prop="nodeOrder" />
        <el-table-column label="审核人" align="center" prop="userName" />
        <el-table-column label="审核状态" align="center" prop="status" />
        <el-table-column label="审核信息" align="center" prop="comment" />

      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
  </div>
</template>

<script setup name="AuditInfo" lang="ts">
import { listInfo, getInfos, delInfo, addInfo, updateInfo } from '@/api/system/info';
import { AuditInfoVO, AuditInfoQuery, AuditInfoForm } from '@/api/system/info/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const auditInfoList = ref<AuditInfoVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const auditInfoFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: AuditInfoForm = {
  appId: undefined,
  nodeOrder: undefined,
  approver: undefined,
  status: undefined,
  comment: undefined,
}
const data = reactive<PageData<AuditInfoForm, AuditInfoQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    appId: undefined,
    nodeOrder: undefined,
    approver: undefined,
    status: undefined,
    comment: undefined,
    params: {
    }
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询【请填写功能名称】列表 */
const getList = async () => {
  loading.value = true;
  const res = await listInfo(queryParams.value);
  auditInfoList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  auditInfoFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: AuditInfoVO[]) => {
  ids.value = selection.map(item => item.appId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加【请填写功能名称】";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: AuditInfoVO) => {
  reset();
  const _appId = row?.appId || ids.value[0]
  const res = await getInfos(_appId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改【请填写功能名称】";
}

/** 提交按钮 */
const submitForm = () => {
  auditInfoFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.appId) {
        await updateInfo(form.value).finally(() =>  buttonLoading.value = false);
      } else {
        await addInfo(form.value).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: AuditInfoVO) => {
  const _appIds = row?.appId || ids.value;
  await proxy?.$modal.confirm('是否确认删除【请填写功能名称】编号为"' + _appIds + '"的数据项？').finally(() => loading.value = false);
  await delInfo(_appIds);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('system/auditInfo/export', {
    ...queryParams.value
  }, `auditInfo_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
